# $Rev: 5320 $, $Date: 2004-06-03 12:28:39 +0200 (Thu, 03 Jun 2004) $
# $Author: longsleep $
# $URL: https://svn.plone.org/svn/plone/Installers/rpms/trunk/Plone2.spec $

# TODO:
# - check why initgroups() crashes on AMD64 and something, better than
#   disabling initgroups() completely, with that and verify if this 
#   happens on fedora64 as well
# - no/more secure initial user/password settings (currently: plone/plone)

%define zope_version 2.7.4-0
%define plone_version 2.0.5
%define plone_tar_version 2.0.5
%define rpm_release 3

# detect distro
%define is_fc   %(test -e /etc/fedora-release && echo 1 || echo 0)
%define is_mdk  %(test -e /etc/mandrake-release && echo 1 || echo 0)
%define is_rh   %(test -e /etc/redhat-release && echo 1 || echo 0)
%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)

# detect fedora core versions
%if %is_fc
%define is_fc3  %(grep -q Heidelberg /etc/fedora-release && echo 1 || echo 0)
%define is_fc2  %(grep -q Tettnang /etc/fedora-release && echo 1 || echo 0)
%define is_fc1  %(grep -q Yarrow   /etc/fedora-release && echo 1 || echo 0)
%else
%define is_fc1 0
%define is_fc2 0
%define is_fc3 0
%endif

# defaults
%define pythonrpm python2.3
%define pythondevelrpm python2.3-devel
%define distro Unknown

# distro specific stuff
%if %is_rh
%define pythonrpm python2.3
%define pythondevelrpm python2.3-devel
%define distro Red Hat Linux
%endif
%if %is_fc1
%define pythonrpm python2.3
%define pythondevelrpm python2.3-devel
%define distro Fedora Core
%endif
%if %is_fc2
%define pythonrpm python
%define pythondevelrpm python-devel
%define distro Fedora Core
%endif
%if %is_fc3
%define pythonrpm python
%define pythondevelrpm python-devel
%define distro Fedora Core
%endif
%if %is_mdk
%define pythonrpm python
%define pythondevelrpm libpython-devel
%define distro Mandrake Linux
%endif
%if %is_suse
%define pythonrpm python
%define pythondevelrpm python-devel
%define distro SuSE Linux
%endif

Summary:        Plone is a free, open source Content Management System based on Zope and the Content Management Framework.
Name:	        Plone2
Version:	%{plone_version}
Release:        %{rpm_release}
License:	Zope Public License (ZPL), GNU General Public Licence (GPL)
Distribution:   %{distro}
Group:		Networking/Daemons
Source0:	http://www.zope.org/Products/Zope/%{zope_version}/%{zope_version}/Zope-%{zope_version}.tgz
Source2:	%{name}.sysconfig
Source3:	%{name}.logrotate
Source4:	%{name}-mkploneinstance
Source5:	%{name}-mkplonezeoinstance
Source6:	%{name}-runplone
Source7:	%{name}-plonectl
Source8:        Plone-%{plone_tar_version}.tar.gz
Source11:       %{name}.init.rh
Source12:       %{name}.init.fc 
Source13:       %{name}.init.mdk
Source14:       %{name}.init.suse
#Source15:	Hotfix-20040807.tar.gz
Source16:       Archetypes-1.3.2-final-Bundle.tar.gz
Source17:       Epoz-0.9.0.tar.gz
Patch0:		%{name}-default_config.patch
Patch1:		%{name}-instance_paths.patch
Patch2:         %{name}-makefile_fix.patch
Patch3:		%{name}-no_initgroups.patch
Patch4:         %{name}-setupSite.patch
Patch5:         %{name}-osnowait.patch
Patch6:		%{name}-CMFCalendar.patch
URL:		http://www.plone.org/
BuildRequires:	%{pythondevelrpm} >= 2.3.3
BuildRequires:	perl
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires(postun):	/usr/sbin/userdel
Requires(postun):	/usr/sbin/groupdel
Requires(post,preun):	/sbin/chkconfig
Requires:	logrotate
Requires:	%{pythonrpm} >= 2.3.3
Requires:       /usr/bin/python2.3
Requires:	expat >= 1.95.5
%if %is_suse
Requires:       python-xml >= 2.3.3
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		zope_dir /usr/lib/plone2

%description
Plone is easy to install. You can install Plone with a click-and-run installer, and have a content management system running on your computer in just a few minutes. Plone is easy to use. The Plone Team includes usability experts who have made Plone easy and attractive for content managers to add, update, and maintain content. Plone is international. The Plone interface has been translated into over 30 languages, and tools exist for managing multilingual content. Plone is standard. Plone carefully follows standards for usability and accessibility. Plone pages are compliant with US Section 508, and the W3C's AAA rating for accessibility, in addition to using  best-practice web standards like XHTML and CSS. Plone is Open Source. Plone is licensed under the GNU General Public License, the same license Linux uses. This gives you the right to use Plone without a license fee, and to improve upon the product. Plone is supported. There are close to a hundred developers in the Plone Development Team around the world, and a multitude of companies specializing in Plone development and support. Plone is extensible. There are many add-on products for Plone that add new features and content types. In addition, Plone can be scripted using web standard solutions and Open Source languages. Plone is technology neutral. Plone can interoperate with most relational database systems, open source and commercial, and runs on a vast array of platforms, including Linux, Windows, Mac OS X, Solaris and BSD.

%prep

%setup -q -n Zope-%{zope_version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%ifarch amd64 alpha
%patch3 -p1
%endif
#%patch5 -p1

%build
perl -pi -e "s|data_dir\s+=\s+.*?join\(INSTANCE_HOME, 'var'\)|data_dir=INSTANCE_HOME|" lib/python/Globals.py

./configure \
	--prefix=%{zope_dir} \
	--optimize \
	--with-python=/usr/bin/python2.3

%{__make}

perl -pi -e "s|data_dir\s+=\s+.*?join\(INSTANCE_HOME, 'var'\)|data_dir=INSTANCE_HOME|" lib/python/Globals.py

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{/var/lib/plone2/main,/var/run/plone2,/var/log/plone2/main} \
	$RPM_BUILD_ROOT{/etc/logrotate.d,/etc/sysconfig,/etc/init.d} \
	$RPM_BUILD_ROOT{%{_sysconfdir}/plone2/main,%{_sbindir}} \
	$RPM_BUILD_ROOT%{zope_dir}/bin

ln -sfn /usr/bin/python2.3 $RPM_BUILD_ROOT%{zope_dir}/bin/python

%{__make} install \
	INSTALL_FLAGS="--root $RPM_BUILD_ROOT"

mv $RPM_BUILD_ROOT%{zope_dir}/bin/zpasswd.py $RPM_BUILD_ROOT%{_sbindir}/zplonepasswd
mv $RPM_BUILD_ROOT%{zope_dir}/skel $RPM_BUILD_ROOT%{_sysconfdir}/plone2
mv $RPM_BUILD_ROOT{%{zope_dir}/import/*,%{_sysconfdir}/plone2/skel/import}

rm -rf $RPM_BUILD_ROOT%{zope_dir}/doc
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/plone2/skel/log
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/plone2/skel/bin/{runzope.bat,zopeservice.py}.in

%if %is_fc
install %{SOURCE12} $RPM_BUILD_ROOT/etc/init.d/plone2
%endif
%if %is_mdk
install %{SOURCE13} $RPM_BUILD_ROOT/etc/init.d/plone2
%endif
%if %is_rh
install %{SOURCE11} $RPM_BUILD_ROOT/etc/init.d/plone2
%endif
%if %is_suse
install %{SOURCE14} $RPM_BUILD_ROOT/etc/init.d/plone2
%endif

install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/plone2
install %{SOURCE3} $RPM_BUILD_ROOT/etc/logrotate.d/plone2
install %{SOURCE4} $RPM_BUILD_ROOT%{_sbindir}/mkploneinstance
install %{SOURCE5} $RPM_BUILD_ROOT%{_sbindir}/mkplonezeoinstance
install %{SOURCE6} $RPM_BUILD_ROOT%{_sbindir}/runplone
install %{SOURCE7} $RPM_BUILD_ROOT%{_sbindir}/plonectl
install %{SOURCE7} $RPM_BUILD_ROOT%{_sbindir}/plonectl

tar -xzf %{SOURCE8}
cd Plone-%{plone_tar_version}
patch -p1 < %{PATCH4}
patch -p1 < %{PATCH6}
rm -rf Archetypes generator MimetypesRegistry PortalTransforms validation 
tar -xzf %{SOURCE16}
tar -xzf %{SOURCE17}
#iconv -f cp1251 -t utf8 Epoz/skins/epoz/epoz_lang_ru.js.dtml > /tmp/epoz_lang_ru.js.dtml
#mv -f /tmp/epoz_lang_ru.js.dtml Epoz/skins/epoz/epoz_lang_ru.js.dtml
#recode -f 1251..utf8 Epoz/skins/epoz/epoz_lang_ru.js.dtml
cd ..
mv -v Plone-%{plone_tar_version}/* $RPM_BUILD_ROOT%{zope_dir}/lib/python/Products
#rm -rf $RPM_BUILD_ROOT%{zope_dir}/lib/python/Products/GroupUserFolder/doc


#cd $RPM_BUILD_ROOT%{zope_dir}/lib/python/Products
#tar -xzf %{SOURCE15}

touch $RPM_BUILD_ROOT/var/log/plone2/main/event.log
touch $RPM_BUILD_ROOT/var/log/plone2/main/Z2.log

%clean
rm -rf $RPM_BUILD_ROOT

%pre
echo "Making group plone (not altered if already exists)."
/usr/sbin/groupadd -r -f plone 2>/dev/null
if [ -z "`id -u plone 2>/dev/null`" ]; then
       echo "Making user plone."
       /usr/sbin/useradd -r -d /var/lib/plone2/main -s /bin/false -c "Plone User" -g plone plone
fi

%post
/sbin/chkconfig --add plone2
if [ ! -f /etc/plone2/main/zope.conf ] ; then
	echo "Creating initial 'main' instance..."
	/usr/sbin/mkploneinstance main plone:plone
	echo "Instance created. Listening on 127.0.0.1:8080, initial user: 'plone' with password: 'plone'."
        echo "For security reasons, Plone only listens on the local interface, and it is common to use Apache to proxy to that particular port to make Plone available to the outside world."
        echo "Check out the how-to section on http://plone.org  if you are unsure about how to set up proxies in Apache."
        echo "Setup of initial database in 'main' instance..."
        /usr/bin/python2.3 /usr/lib/plone2/lib/python/Products/CMFPlone/Extensions/setupSite.py plone /usr/lib/plone2/lib/python /var/lib/plone2/main >&2
        echo "Created initial database content."
else
	echo "Old /etc/plone2/main/zope.conf detected - look at changes about upgrade!" >&2
fi
was_stopped=0
for dir in /var/lib/plone2/main/var /var/lib/plone ; do
	if [ -f $dir/Data.fs ]; then
		echo "Found the database in old location. Using this for the 'main' instance..."
		if [ -f /var/lock/subsys/plone2 ]; then
		    /etc/init.d/plone2 stop >&2
		    was_stopped=1
		fi
		umask 022
		[ -d /var/lib/plone2/main ] && cd $dir && cp -pf Data* /var/lib/plone2/main/var 2>/dev/null
		if [ "x$was_stopped" = "x1" ]; then
		    /etc/init.d/plone2 start >&2
		fi
		echo "New database location is /var/lib/plone2/main/var."
		break
	fi
done
if [ -f /var/lock/subsys/plone2 ]; then
	if [ "x$was_stopped" != "x1" ]; then
	    /etc/init.d/plone2 restart >&2
	fi
else
	echo "look at /etc/plone2/main/zope.conf." >&2
	echo "Run then \"/etc/init.d/plone2 start\" to start Plone2." >&2
	echo "you may create new Plone instances with mkploneinstance." >&2
fi

%preun
if [ "$1" = "0" ]; then
	if [ -f /var/lock/subsys/plone2 ]; then
		/etc/init.d/plone2 stop
	fi
	/sbin/chkconfig --del plone2
fi

%postun
if [ "$1" = "0" ] ; then
       echo "Removing user plone."
       /usr/sbin/userdel plone >/dev/null 2>&1 || :
       echo "Removing group plone."
       /usr/sbin/groupdel plone >/dev/null 2>&1 || :
fi

%files
%defattr(644,root,root,755)
%doc doc/* 
%doc %{zope_dir}/lib/python/Products/CMFPlone/docs/* 
%doc %{zope_dir}/lib/python/Products/CMFPlone/LICENSE.* 
%doc %{zope_dir}/lib/python/Products/CMFPlone/CREDITS.txt
%doc %{zope_dir}/lib/python/Products/CMFPlone/HISTORY.txt
%doc %{zope_dir}/lib/python/Products/CMFPlone/INSTALL.txt
%doc %{zope_dir}/lib/python/Products/CMFPlone/UPGRADE.txt

%attr(754,root,root) /etc/init.d/plone2
%attr(755,root,root) %{_sbindir}/*
%{zope_dir}
%attr(775,plone,plone) %dir /var/run/plone2
%attr(775,plone,plone) %dir /var/lib/plone2
%attr(775,plone,plone) %dir /var/lib/plone2/main
%attr(775,plone,plone) %dir /var/log/plone2
%attr(775,plone,plone) %dir /var/log/plone2/main
%attr(640,root,root) %dir /etc/plone2
%attr(640,root,root) %dir /etc/plone2/skel
%attr(640,root,root) %dir /etc/plone2/main
%attr(640,root,root) %config(noreplace) %verify(not md5 size mtime) /etc/plone2/skel/*
%attr(640,root,root) /etc/logrotate.d/plone2
%attr(640,root,root) /etc/sysconfig/plone2
%ghost /var/log/plone2/main/event.log
%ghost /var/log/plone2/main/Z2.log

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} Oleg Sadov <sadov@linux-ink.ru>
Adopted for Zope 2.7.4, Plone 2.0.5

* %{date} Simon Eisenmann <simon@longsleep.org>

$Log: Plone2.spec,v $
Revision 1.10  2004/05/12 15:24:39  longsleep
changed mdk build dependecy
use OSNOWAIT mixup patch

Revision 1.9  2004/05/12 08:48:26  longsleep
prepare packaging of plone 2.0.2

Revision 1.8  2004/04/02 12:58:08  longsleep
rpms now can be build on rh, fc, mdk and suse

Revision 1.7  2004/04/02 10:56:43  longsleep
for limis sake added a more detailed warning about plone only listening on lo ;)

Revision 1.6  2004/04/02 10:44:58  longsleep
suse doesnt have /etc/rc.d/init.d use /etc/init.d instead

Revision 1.5  2004/04/02 10:20:37  longsleep
another step to provide distro independent source rpm

Revision 1.4  2004/04/02 10:14:20  longsleep
prepare new rpm release

Revision 1.3  2004/03/31 21:31:39  longsleep
dont mark rpms distro specific per default
allow source rpm to compile on any known distribution

Revision 1.2  2004/03/31 20:31:23  longsleep
also detect fc rpm

Revision 1.1  2004/03/31 15:18:25  longsleep
merged to one spec file for any distro

Revision 1.9  2004/03/22 19:18:46  longsleep
release 2

Revision 1.8  2004/03/20 20:42:12  longsleep
beautify docs
dont show deprecation warning when setupSite.py is run

Revision 1.7  2004/03/19 22:39:01  longsleep
first i write python2 then i write phone2 .. its too late

Revision 1.6  2004/03/19 22:22:14  longsleep
copy plone1 data.fs to plone2's main instance if found
run setupSite.py in %post (right after installation)

Revision 1.5  2004/03/19 21:59:10  longsleep
stripped old stuff

Revision 1.4  2004/03/18 16:10:29  longsleep
support for setupSite.py added

Revision 1.3  2004/03/18 14:10:59  longsleep
mark plone docs as docs

Revision 1.2  2004/03/18 13:40:35  longsleep
include Plone inside the rpm

Revision 1.1  2004/03/13 22:08:48  longsleep
nothing more than plain zope yet .. but it claims to be plone2 ;)


